<?php
/**
* Settings class
*
* CMS Settings management
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>
* @access		public
* @module		settings
* @modulegroup	core
* @version		1.0.0
*/  

class settingsManager
{
    var $_objTpl;
	var $pagetitle;
	var $pageContent;
	var $statusMessage="";
	var $_selectedLang;
		
	/**
    * Constructor
    *
    * @param  string  
    * @access public
    */
    function settingsManager() { 
    	global  $_CORELANG, $objTemplate;
		
        $objTemplate->setVariable("CONTENT_NAVIGATION","<a href='?cmd=settings'>".$_CORELANG['TXT_SYSTEM_SETTINGS']."</a>");  
    }

    
    /**
    * Gets the requested methods
    *  
    * @global array  $_CORELANG
    * @global object  $objTemplate    
    * @return string  parsed content                                                                               
    */
    function getPage()
    {    
   	    global $_CORELANG, $objTemplate;
    	
    	if(!isset($_GET['act'])){
    	    $_GET['act']="";	
    	}
    	
        switch($_GET['act']){
			case "update":
			    $this->update();
			    $this->showSettings();		        	
			break;							    								
			default:
			    $this->showSettings();           
			break;        	     		        
		}
		$objTemplate->setVariable(array(
			'CONTENT_TITLE'				=> $this->pageTitle,
			'CONTENT_STATUS_MESSAGE'	=> $this->statusMessage
		));
    }     

	/**
	* Get settings
	*
	* Shows the cms system settings
	*
	* @global  object $objDatabase
	* @global  array  $_CORELANG                                                                         
	*/
	function showSettings()
	{
		global $objDatabase, $_CORELANG, $objTemplate;
		
		$objTemplate->addBlockfile('ADMIN_CONTENT', 'settings', 'settings.html');
		$this->pageTitle = $_CORELANG['TXT_SYSTEM_SETTINGS']; 			
		
		$objTemplate->setVariable(array(
		    'TXT_SYSTEM_SETTINGS_OVERVIEW' 	=> $_CORELANG['TXT_SYSTEM_SETTINGS_OVERVIEW'], 
		    'TXT_SAVE_CHANGES' 				=> $_CORELANG['TXT_SAVE_CHANGES'],
		    'TXT_ADMIN_EMAIL' 				=> "Email-Adresse des Administrators",
		    'TXT_ADMIN_NAME' 				=> $_CORELANG['TXT_ADMIN_NAME'],		    
		    'TXT_PAGING_LIMIT' 				=> "Datenstze pro Seite",
		    'TXT_PAGING_LIMIT_HELP' 		=> "Zwischen 1 und 200 mglich",
		    'TXT_SEARCH_RESULT' 			=> "Zeichen bei Suchergebnissen",
		    'TXT_SEARCH_RESULT_HELP' 		=> "Anzahl der Zeichen fr die Beschreibung der Suchergebnissen",		    
		    'TXT_SESSION_LIVETIME' 			=> "Session Dauer",
		    'TXT_SESSION_LIVETIME_HELP' 	=> "Die Session Zeit in Sekunden",
		    'TXT_IDS_STATUS' 				=> "Sicherheitssystem",
		    'TXT_IDS_STATUS_HELP' 			=> "Contrexx Intrusion Detection System - Status on|off",
		    'TXT_HISTORY_STATUS' 			=> $_CORELANG['TXT_CONTENT_HISTORY_WORKFFLOW'],		   	    
		    'TXT_HISTORY_STATUS_HELP' 		=> $_CORELANG['TXT_CONTENT_HISTORY_HELP'],
		    'TXT_CONTACT_EMAIL' 			=> "Email-Adresse Kontaktformular (Standard)",
		    'TXT_CONTACT_EMAIL_HELP' 		=> "Empfnger-Emailadressen fr das Standardformular (keine id angegeben). Mehrere Empfngeradressen jeweils durch Kommas trennen.",
		    'TXT_ADMIN_EMAIL' 				=> "Email-Adresse des Administrators",
		    'TXT_ADMIN_NAME' 				=> "Name des Administrators",
		    'TXT_DNS_SERVER' 				=> $_CORELANG['TXT_DNS_SERVER'],
		    'TXT_DNS_SERVER_HELP' 			=> $_CORELANG['TXT_DNS_SERVER_HELP']
		));			
		
		$objResult = $objDatabase->Execute("SELECT setid, setname, setvalue, setmodule FROM ".DBPREFIX."settings");
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$arrSettings[$objResult->fields['setname']]=$objResult->fields['setvalue'];
				$objResult->MoveNext();
			}
		}
		
		$objTemplate->setVariable(array(
		    'SETTINGS_CONTACT_EMAIL' 		=> stripslashes($arrSettings['contactFormEmail']),
		    'SETTINGS_ADMIN_EMAIL' 			=> stripslashes($arrSettings['coreAdminEmail']),
		    'SETTINGS_ADMIN_NAME' 			=> stripslashes($arrSettings['coreAdminName']),
		    'SETTINGS_PAGING_LIMIT' 		=> intval($arrSettings['corePagingLimit']),
		    'SETTINGS_SEARCH_RESULT_LENGTH' => intval($arrSettings['searchDescriptionLength']),		    
		    'SETTINGS_SESSION_LIFETIME' 	=> intval($arrSettings['sessionLifeTime']),
		    'SETTINGS_IDS_STATUS' 			=> stripslashes($arrSettings['coreIdsStatus']),
		    'SETTINGS_DNS_SERVER' 			=> stripslashes($arrSettings['dnsServer']),
		    'SETTINGS_HISTORY_STATUS'		=> $arrSettings['contentHistoryStatus']
		));
	}
	
	/**
	* Update settings value
	*
	* Update setting variables
	* 
	* @global  object  $objDatabase                                                                      
	*/
	function update()
	{
		global $objDatabase;
		
		foreach ($_POST['setvalue'] as $id => $value) {
			if (intval($id) == 43) {
				$value = ($value == 'on') ? 'on' : 'off';	
			}
			$objDatabase->Execute("UPDATE ".DBPREFIX."settings 
			                          SET setvalue='".htmlspecialchars($value)."' 
			                        WHERE setid=".intval($id));		
		}				
	}
}
?>