<?php
/**
* Class contact library
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>            
* @module		contact
* @modulegroup	core_modules
* @access		public
* @version		1.0.0
*/
class ContactLib
{
	var $arrForms;
	var $_arrSettings;
	
	
	/**
	* Constructor
	*/
	function ContactLib()
	{
		$this->__construct();
	}
	
	/**
	* PHP5 constructor
	*
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function __construct()
	{
		
	}
	
	function initContactForms()
	{
		global $objDatabase;
		
		$objContactForms = $objDatabase->Execute("SELECT tblForm.id, tblForm.name, tblForm.mails, COUNT(tblData.id) AS number, MAX(tblData.time) AS last
												FROM ".DBPREFIX."module_contact_form AS tblForm
												LEFT OUTER JOIN ".DBPREFIX."module_contact_form_data AS tblData ON tblForm.id=tblData.id_form
												GROUP BY tblForm.id
												ORDER BY last DESC");
		if ($objContactForms !== false) {
			while (!$objContactForms->EOF) {
				$this->arrForms[$objContactForms->fields['id']] = array(
					'name'	=> $objContactForms->fields['name'],
					'emails'	=> $objContactForms->fields['mails'],
					'number'	=> intval($objContactForms->fields['number']),
					'last'		=> intval($objContactForms->fields['last'])
				);
				
				$objContactForms->MoveNext();
			}
		}
	}
	
	function initSettings()
	{
		global $objDatabase;
		
		$this->_arrSettings = array();
		$objSettings = $objDatabase->Execute("SELECT setname, setvalue FROM ".DBPREFIX."module_contact_settings");
		
		if ($objSettings !== false) {
			while (!$objSettings->EOF) {
				$this->_arrSettings[$objSettings->fields['setname']] = $objSettings->fields['setvalue'];
				$objSettings->MoveNext();
			}
		}
	}
	
	function getSettings($reinitialize = false)
	{
		if (!isset($this->_arrSettings) || $reinitialize) {
			$this->initSettings();
		}
		return $this->_arrSettings;
	}
	
	function getContactFormEmails($id)
	{
		global $objDatabase;
		
		$arrEmails = array();
		$objContactForm = $objDatabase->SelectLimit("SELECT mails FROM ".DBPREFIX."module_contact_form WHERE id=".$id, 1);
		
		if ($objContactForm !== false) {
			if ($objContactForm->RecordCount() == 1) {
				$this->arrForms[$id] = array();
				$arrEmails = explode(',', $objContactForm->fields['mails']);
			}
		}
		
		return $arrEmails;
	}
	
	function getFormFields($id)
	{
		global $objDatabase;
		
		$arrFields = array();
		
		if (isset($this->arrForms[$id])) {
			$objFields  = $objDatabase->Execute("SELECT id, name, type, attributes FROM ".DBPREFIX."module_contact_form_field WHERE id_form=".$id." ORDER BY order_id");
			
			if ($objFields !== false) {
				while (!$objFields->EOF) {
					$arrFields[$objFields->fields['id']] = array(
						'name'			=> $objFields->fields['name'],
						'type'			=> $objFields->fields['type'],
						'attributes'	=> $objFields->fields['attributes']
					);
					$objFields->MoveNext();
				}
			}
			return $arrFields;
		} else {
			return false;
		}
	}
	
	function getFormFieldNames($id)
	{
		global $objDatabase;
		
		$arrFieldNames = array();
		
		if (isset($this->arrForms[$id])) {
			$objFields  = $objDatabase->Execute("SELECT id, name FROM ".DBPREFIX."module_contact_form_field WHERE id_form=".$id." ORDER BY order_id");
			
			if ($objFields !== false) {
				while (!$objFields->EOF) {
					$arrFieldNames[$objFields->fields['name']] = $objFields->fields['id'];
					$objFields->MoveNext();
				}
			}
			return $arrFieldNames;
		} else {
			return false;
		}
	}
	
	function isUniqueFormName($name, $id = 0)
	{
		if (is_array($this->arrForms)) {
			foreach ($this->arrForms as $formId => $arrForm) {
				if ($formId != $id && $arrForm['name'] == $name) {
					return false;
				}
			}
		}
		return true;
	}
	
	function updateForm($id, $name, $emails, $arrFields)
	{
		global $objDatabase;
		
		$objDatabase->Execute("UPDATE ".DBPREFIX."module_contact_form SET name='".$name."', mails='".$emails."' WHERE id=".$id);
		
		$arrFormFields = $this->getFormFields($id);
		$arrRemoveFormFields = array_diff_assoc($arrFormFields, $arrFields);
		
		foreach ($arrFields as $fieldId => $arrField) {
			if (isset($arrFormFields[$fieldId])) {
				$this->_updateFormField($fieldId, $arrField['name'], $arrField['type'], $arrField['attributes'], $arrField['order_id']);
			} else {
				$this->_addFormField($id, $arrField['name'], $arrField['type'], $arrField['attributes'], $arrField['order_id']);
			}
		}
		
		foreach (array_keys($arrRemoveFormFields) as $fieldId) {
			$this->_deleteFormField($fieldId);
		}
		
		$this->initContactForms();
	}
	
	function addForm($name, $emails, $arrFields)
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_contact_form (`name`,`mails`) VALUES ('".$name."', '".$emails."')") !== false) {
			$formId = $objDatabase->Insert_ID();
			
			foreach ($arrFields as $fieldId => $arrField) {
				$this->_addFormField($formId, $arrField['name'], $arrField['type'], $arrField['attributes'], $arrField['order_id']);
			}
		}
		$_REQUEST['formId'] = $formId;
		
		$this->initContactForms();
	}
	
	function deleteForm($id)
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_contact_form WHERE id=".$id) !== false) {
			$this->_deleteFormFieldsByFormId($id);
			$this->_deleteFormDataByFormId($id);
		}
		
		$this->initContactForms();
	}
	
	function _updateFormField($id, $name, $type, $attributes, $orderId)
	{
		global $objDatabase;
		
		$objDatabase->Execute("UPDATE ".DBPREFIX."module_contact_form_field SET name='".$name."', type='".$type."', attributes='".$attributes."', order_id=".$orderId." WHERE id=".$id);
	}
	
	function _addFormField($formId, $name, $type, $attributes, $orderId)
	{
		global $objDatabase;
		
		$objDatabase->Execute("INSERT INTO ".DBPREFIX."module_contact_form_field (`id_form`, `name`, `type`, `attributes`, `order_id`) VALUES (".$formId.", '".$name."', '".$type."', '".$attributes."', ".$orderId.")");
	}
	
	function _deleteFormField($id)
	{
		global $objDatabase;
		
		$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_contact_form_field WHERE id=".$id);
	}
	
	function _deleteFormFieldsByFormId($id)
	{
		global $objDatabase;
		
		$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_contact_form_field WHERE id_form=".$id);
	}
	
	function _deleteFormDataByFormId($id)
	{
		global $objDatabase;
		
		$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_contact_form_data WHERE id_form=".$id);
	}
	
	function deleteFormEntry($id)
	{
		global $objDatabase;
		
		$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_contact_form_data WHERE id=".$id);
	}
	
	function getFormEntries($formId, &$arrCols, $pagingPos, &$paging)
	{
		global $objDatabase, $_CONFIG;
		
		$arrEntries = array();
		$arrCols = array();
		
		$query = "SELECT id, `time`, `host`, `lang`, `ipaddress`, data FROM ".DBPREFIX."module_contact_form_data WHERE id_form=".$formId." ORDER BY `time` DESC";
		$objEntry = $objDatabase->Execute($query);
		
		$count = $objEntry->RecordCount();
		if ($count > intval($_CONFIG['corePagingLimit'])) {
			$paging = getPaging($count, $pagingPos, "&amp;cmd=contact&amp;act=forms&amp;tpl=entries&amp;formId=".$formId, 'Kontaktformular Eintrge');
			$objEntry = $objDatabase->SelectLimit($query, $_CONFIG['corePagingLimit'], $pagingPos);
		}
		
		if ($objEntry !== false) {
			while (!$objEntry->EOF) {
				$arrKeyValue = explode(';', $objEntry->fields['data']);
				$arrData = array();
				foreach ($arrKeyValue as $keyValue) {
					$arrTmp = explode(',', $keyValue);
					$arrData[base64_decode($arrTmp[0])] = base64_decode($arrTmp[1]);
					
					if (!in_array(base64_decode($arrTmp[0]), $arrCols)) {
						array_push($arrCols, base64_decode($arrTmp[0]));
					}
				}
				
				$arrEntries[$objEntry->fields['id']] = array(
					'time'		=> $objEntry->fields['time'],
					'host'		=> $objEntry->fields['host'],
					'lang'		=> $objEntry->fields['lang'],
					'ipaddress'	=> $objEntry->fields['ipaddress'],
					'data'		=> $arrData
				);
				$objEntry->MoveNext();
			}
		}
		
		return $arrEntries;
	}
	
	function getFormEtry($id)
	{
		global $objDatabase;
		
		$arrEntry;
		$arrCols = array();
		$objEntry = $objDatabase->SelectLimit("SELECT `time`, `host`, `lang`, `ipaddress`, data FROM ".DBPREFIX."module_contact_form_data WHERE id=".$id, 1);
		
		if ($objEntry !== false) {
			$arrKeyValue = explode(';', $objEntry->fields['data']);
			$arrData = array();
			foreach ($arrKeyValue as $keyValue) {
				$arrTmp = explode(',', $keyValue);
				$arrData[base64_decode($arrTmp[0])] = base64_decode($arrTmp[1]);
				
				if (!in_array(base64_decode($arrTmp[0]), $arrCols)) {
					array_push($arrCols, base64_decode($arrTmp[0]));
				}
			}
			
			$arrEntry = array(
				'time'		=> $objEntry->fields['time'],
				'host'		=> $objEntry->fields['host'],
				'lang'		=> $objEntry->fields['lang'],
				'ipaddress'	=> $objEntry->fields['ipaddress'],
				'data'		=> $arrData
			);
		}
		
		return $arrEntry;
	}
}
?>
