<?php
/**
* Class demoModule
*
* demo module class
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>            
* @module		demoModule
* @modulegroup	modules
* @access		public
* @version		1.0.0
*/
require_once ASCMS_FRAMEWORK_PATH.'/System.class.php';
require_once ASCMS_FRAMEWORK_PATH.'/File.class.php';
require_once ASCMS_CORE_PATH.'/Tree.class.php';

class FileBrowser
{
	/**
	* Template object
	*
	* @access private
	* @var object
	*/
	var $_objTpl;
	
	/**
	* Page title
	*
	* @access private
	* @var string
	*/
	var $_pageTitle;
	
	/**
	* Status message
	*
	* @access private
	* @var string
	*/
	var $_statusMessage = '';
	
	var $_arrFiles = array();
	var $_arrDirectories = array();
	var $_path = "";
	var $_iconWebPath = '';
	
	/**
	* Media type
	*
	* @access private
	* @var string
	*/
	var $_mediaType = '';
	
	/**
	* Webpages
	*
	* @access private
	* @var array
	*/
	var $_arrWebpages = array();
	
	var $_arrMediaTypes = array('files' => 'TXT_FILEBROWSER_FILES', 'webpages' => 'TXT_FILEBROWSER_WEBPAGES');
	
	/**
	* Constructor
	*/
	function FileBrowser()
	{
		$this->__construct();
	}
	
	/**
	* PHP5 constructor
	*
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function __construct()
	{
		global $_ARRAYLANG;
		$_ARRAYLANG['TXT_FILEBROWSER_FILES'] = "Dateien";
		$_ARRAYLANG['TXT_FILEBROWSER_WEBPAGES'] = "Webseiten";
		$_ARRAYLANG['TXT_FILEBROWSER_PREVIEW'] = "Vorschau";
		
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_CORE_MODULE_PATH.'/fileBrowser/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
		
		$this->_iconPath = ASCMS_MODULE_IMAGE_WEB_PATH.'/fileBrowser/';
		$this->_path = $this->_getPath();
		$this->_mediaType = $this->_getMediaType();
		
		$this->_checkUpload();
		$this->_initFiles();
	}
	
	/**
	* Get media type
	*
	* Get the type of which media content should be displayed in the file browser
	*
	* @access private
	* @see FileBrowser::_arrMediaTypes
	*/
	function _getMediaType()
	{
		if (isset($_REQUEST['type']) && isset($this->_arrMediaTypes[$_REQUEST['type']])) {
			return $_REQUEST['type'];
		} else {
			return 'files';
		}
	}
	
	function _getPath()
	{
		$path = "";
		if (isset($_REQUEST['path']) && !stristr($_REQUEST['path'], '..')) {
			$path = $_REQUEST['path'];
		}
		$pos = strrpos($path, '/');
		if ($pos === false || $pos != (strlen($path)-1)) {
			$path .= "/";
		}
		
		return $path;
	}
	
	/**
	* Set the backend page
	*
	* @access public
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function getPage() 
	{
		if (!isset($_REQUEST['act'])) {
			$_REQUEST['act'] == '';
		}
		$this->_initWebSites();
		switch ($_REQUEST['act']) {
		case 'FCKEditorUpload':
			$this->_FCKEditorUpload();
			break;
			
		default:
			$this->_showFileBrowser();
			break;
		}
	}
	
	function SendResults( $errorNumber, $fileUrl = '', $fileName = '', $customMsg = '' )
	{
		echo '<script type="text/javascript">' ;
		echo 'window.parent.OnUploadCompleted(' . $errorNumber . ',"' . str_replace( '"', '\\"', $fileUrl ) . '","' . str_replace( '"', '\\"', $fileName ) . '", "' . str_replace( '"', '\\"', $customMsg ) . '") ;' ;
		echo '</script>' ;
		exit ;
	}
	
	function _FCKEditorUpload()
	{
		if (!isset($_FILES['NewFile']) || is_null($_FILES['NewFile']['tmp_name']) || $_FILES['NewFile']['name'] == '') {
			$this->SendResults('202');
		} else {
			$this->_uploadFile($_FILES['NewFile']['name'], $_FILES['NewFile']['tmp_name'], $uploadFileName);
			$this->SendResults( 0, ASCMS_CONTENT_IMAGE_WEB_PATH.$this->_path.$uploadFileName, $uploadFileName);
		}
	}
	
	/**
	* Show file browser
	*
	* Show the file browser
	*
	* @access private
	* @global array $_ARRAYLANG
	*/
	function _showFileBrowser()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_fileBrowser_frame.html');
		
		$this->_objTpl->setVariable(array(
			'FILEBROWSER_WEB_PATH'	=> ASCMS_CONTENT_IMAGE_WEB_PATH.$this->_path,
			'TXT_CLOSE'				=> $_ARRAYLANG['TXT_CLOSE']
		));
		
		$this->_setNaviagtion();
		$this->_setContent();
		$this->_setUploadForm();
		
		$this->_objTpl->show();
	}
	
	function _checkUpload()
	{
		if (isset($_FILES['fileBrowserUploadFile']) && !empty($_FILES['fileBrowserUploadFile'])) {
			$this->_uploadFile($_FILES['fileBrowserUploadFile']['name'], $_FILES['fileBrowserUploadFile']['tmp_name'],$tmp);
		}
	}
	
	function _uploadFile($uploadFileName, $tmpFileName, &$uploadedFileName)
	{
		$file = $uploadFileName;
		$fileExtension = '';
		
		$nr = 1;
		
		if (@file_exists(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$uploadFileName)) {
			if (preg_match('/.*\.(.*)$/', $uploadFileName, $arrSubPatterns)) {
				$fileName = substr($uploadFileName, 0, strrpos($uploadFileName, '.'));
				$fileExtension = $arrSubPatterns[1];
				$file = $fileName.'-'.$nr.'.'.$fileExtension;
				
				while (@file_exists(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)) {
					$file = substr($uploadFileName, 0, strrpos($uploadFileName, '.')).'-'.$nr.'.'.$fileExtension;
					$nr++;
				}
			} else {
				return false;
			}
		}
		$uploadedFileName = $file;
		
		move_uploaded_file($tmpFileName, ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
		
		$objFile = &new File();
		$objFile->setChmod(ASCMS_CONTENT_IMAGE_PATH.$this->_path, ASCMS_CONTENT_IMAGE_WEB_PATH.$this->_path, $file);
	}
	
	/**
	* Set the navigation in the file browser
	*
	* Set the navigation with the media type drop-down menu in the file browser
	*
	* @access private
	* @see FileBrowser::_getMediaTypeMenu, _objTpl, _mediaType, _arrDirectories
	*/
	function _setNaviagtion()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->addBlockfile('FILEBROWSER_NAVIGATION', 'fileBrowser_navigation', 'module_fileBrowser_navigation.html');
		
		$this->_objTpl->setVariable(array(
			'FILEBROWSER_MEDIA_TYPE_MENU'	=> $this->_getMediaTypeMenu('fileBrowserType', $this->_mediaType, 'onchange="window.location.replace(\'index.php?cmd=fileBrowser&amp;standalone=true&amp;type=\'+this.value)" style="width:180px;"'),
			'TXT_FILEBROWSER_PREVIEW'		=> $_ARRAYLANG['TXT_FILEBROWSER_PREVIEW']
		));
		
		if ($this->_mediaType == 'files') {
			// only show directories if the files should be displayed
			if (count($this->_arrDirectories) > 0) {
				foreach ($this->_arrDirectories as $arrDirectory) {
					$this->_objTpl->setVariable(array(
						'FILEBROWSER_FILE_PATH'	=> "index.php?cmd=fileBrowser&amp;standalone=true&amp;path=".$arrDirectory['path'],
						'FILEBROWSER_FILE_NAME'	=> $arrDirectory['name'],
						'FILEBROWSER_FILE_ICON'	=> $arrDirectory['icon']
					));
					$this->_objTpl->parse('navigation_directories');
				}
			}
		}
		
		$this->_objTpl->parse('fileBrowser_navigation');
	}
	
	function _setContent()
	{
		global $objDatabase;
		
		$this->_objTpl->addBlockfile('FILEBROWSER_CONTENT', 'fileBrowser_content', 'module_fileBrowser_content.html');
		
		$rowNr = 0;
		
		switch ($this->_mediaType) {
		case 'webpages':
			//$this->_initWebSites();
			$arrModules = array();
			$objResult = $objDatabase->Execute('SELECT id, name FROM ".DBPREFIX."modules');
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					$arrModules[$objResult->fields['id']] = $objResult->fields['name'];
					$objResult->MoveNext();
				}
			}
			
			$objContentTree = &new ContentTree();
			foreach ($objContentTree->getTree() as $arrPage) {
				$s = $arrModules[$arrPage['moduleid']];
				$c = $arrPage['cmd'];
				$section = ($s=="") ? "" : "&amp;section=$s"; 
				$cmd = ($c=="") ? "" : "&amp;cmd=$c"; 
				$link = (!empty($s)) ? "?section=".$s.$cmd : "?page=".$arrPage['catid'].$section.$cmd;
				
				$this->_objTpl->setVariable(array(
					'FILEBROWSER_ROW_CLASS'			=> $rowNr%2 == 0 ? "row1" : "row2",
					'FILEBROWSER_FILE_PATH_CLICK'	=> "javascript:{setUrl('".ASCMS_PATH_OFFSET.'/index.php'.$link."')}",
					'FILEBROWSER_FILE_NAME'			=> $arrPage['catname'],
					'FILEBROWSER_FILESIZE'			=> '&nbsp;',
					'FILEBROWSER_FILE_ICON'			=> $this->_iconPath.'htm.gif',
					'FILEBROWSER_FILE_DIMENSION'	=> '&nbsp;',
					'FILEBROWSER_SPACER'			=> '<img src="'.ASCMS_ADMIN_WEB_PATH.'/images/pixel.gif'.'" width="'.($arrPage['level']*16).'" height="1" />'
				));
				$this->_objTpl->parse('content_files');
				
				$rowNr++;
			}
			
			break;
		
		default:
			if (count($this->_arrDirectories) > 0) {
				foreach ($this->_arrDirectories as $arrDirectory) {
					$this->_objTpl->setVariable(array(
						'FILEBROWSER_ROW_CLASS'			=> $rowNr%2 == 0 ? "row1" : "row2",
						'FILEBROWSER_FILE_PATH_CLICK'	=> "index.php?cmd=fileBrowser&amp;standalone=true&amp;path=".$arrDirectory['path'],
						'FILEBROWSER_FILE_NAME'			=> $arrDirectory['name'],
						'FILEBROWSER_FILESIZE'			=> '&nbsp;',
						'FILEBROWSER_FILE_ICON'			=> $arrDirectory['icon'],
						'FILEBROWSER_FILE_DIMENSION'	=> '&nbsp;'
					));
					$this->_objTpl->parse('content_files');
					
					$rowNr++;
				}
			}
			if (count($this->_arrFiles) > 0) {
				foreach ($this->_arrFiles as $arrFile) {
					$this->_objTpl->setVariable(array(
						'FILEBROWSER_ROW_CLASS'				=> $rowNr%2 == 0 ? "row1" : "row2",
						'FILEBROWSER_FILE_PATH_DBLCLICK'	=> "setUrl('".$arrFile['path']."',".$arrFile['width'].",".$arrFile['height'].",'')",
						'FILEBROWSER_FILE_PATH_CLICK'		=> "javascript:{showPreview('".$arrFile['path']."',".$arrFile['width'].",".$arrFile['height'].")}",
						'FILEBROWSER_FILE_NAME'				=> $arrFile['name'],
						'FILEBROWSER_FILESIZE'				=> $arrFile['size'].' KB',
						'FILEBROWSER_FILE_ICON'				=> $arrFile['icon'],
						'FILEBROWSER_FILE_DIMENSION'		=> (empty($arrFile['width']) && empty($arrFile['height'])) ? '' : intval($arrFile['width']).'x'.intval($arrFile['height'])
					));
					$this->_objTpl->parse('content_files');
					
					$rowNr++;
				}
			}
			
			$this->_objTpl->setVariable('FILEBROWSER_IMAGE_PATH', ASCMS_CONTENT_IMAGE_WEB_PATH);
			break;
		}
		
		
		$this->_objTpl->parse('fileBrowser_content');
	}
	
	function _setUploadForm()
	{
		$objFWSystem = &new FWSystem();
		
		$this->_objTpl->addBlockfile('FILEBROWSER_UPLOAD', 'fileBrowser_upload', 'module_fileBrowser_upload.html');
		$this->_objTpl->setVariable(array(
			'FILEBROWSER_UPLOAD_PATH'	=> $this->_path,
			'FILEBROWSER_MAX_FILE_SIZE'	=> $objFWSystem->getMaxUploadFileSize(),
			'TXT_UPLOAD_FILE'			=> 'Datei hinaufladen'
		));
		
		$this->_objTpl->parse('fileBrowser_upload');
	}
	
	function _initFiles()
	{
		$objDir = @opendir(ASCMS_CONTENT_IMAGE_PATH.$this->_path);
		
		$arrFiles = array();
		
		if ($objDir) {
			if ($this->_path !== "/" && preg_match('#(.*/).+[/]?$#',$this->_path, $path)) {
				array_push($this->_arrDirectories, array('name' => '..', 'path' => $path[1], 'icon' => $this->_iconPath.'_folder.gif'));
			}
			
			while ($file = readdir($objDir)) {
				if ($file == '.' || $file == '..' || preg_match('/\.thumb$/', $file)) {
					continue;
				}
				array_push($arrFiles, $file);
			}
			closedir($objDir);
			
			sort($arrFiles);
			
			foreach ($arrFiles as $file) {
				if (is_dir(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)) {
					array_push($this->_arrDirectories, array('name' => $file, 'path' => $this->_path.$file, 'icon' => $this->_getIcon(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)));
				} else {
					$filesize = @filesize(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
					if ($filesize > 0) {
						$filesize = round($filesize/1024);
					} else {
						$filesize = 0;
					}
					$arrDimensions = @getimagesize(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
					array_push($this->_arrFiles, array('name' => $file, 'path' => $this->_path.$file, 'size' => $filesize, 'icon' => $this->_getIcon(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file), 'width' => intval($arrDimensions[0]), 'height' => intval($arrDimensions[1])));
				}
			}
		}
	}
	
	function _initWebSites()
	{
		global $objDatabase, $_FRONTEND_LANGID;
		
		/*
		$objPage = $objDatabase->Execute("SELECT n.cmd AS cmd,
				n.catid AS catid,
				n.catname AS catname,
				n.parcat AS parcat,
				n.
				m.name AS section 
			FROM ".DBPREFIX."content_navigation AS n,
				".DBPREFIX."modules AS m 
			WHERE n.module=m.id AND n.lang=".$_FRONTEND_LANGID);
		
		if ($objPage !== false) {
			while (!$objPage->EOF) {
				$s = $objPage->fields['section'];
				$c = $objPage->fields['cmd'];
				$section = ($s=="") ? "" : "&amp;section=$s"; 
				$cmd = ($c=="") ? "" : "&amp;cmd=$c"; 
				$link = (!empty($s)) ? "?section=".$s.$cmd : "?page=".$objPage->fields['catid'].$section.$cmd;
				
				$this->_arrWebpages[$objPage->fields['catid']] = $_SERVER['PHP_SELF'].$link;
				//$sFiles .= "<File name=\"". ConvertToXmlAttribute($objResult->fields['catname']) ."\" size=\"0\" path=\"".$_SERVER['SERVER_NAME'].ASCMS_PATH_OFFSET.'/index.php'.$link."\"/>\n";
				$objPage->MoveNext();
			}
			
			print_r($this->_arrWebpages);
		}
		*/
	}
	
	// gets the icon for the file
    function _getIcon($file)
    {
        if (is_file($file)) {
            $info = pathinfo($file);
		    $icon = $info['extension'];
        }
        
        if (is_dir($file)) {
            $icon = '_folder';
        }
        
        if (!file_exists(ASCMS_MODULE_IMAGE_PATH.'/fileBrowser/'.$icon.'.gif') or !isset($icon)){
			$icon = '_blank';
		}
		return $this->_iconPath.$icon.'.gif';
    }
    
    function _getMediaTypeMenu($name, $selectedType, $attrs)
    {
    	global $_ARRAYLANG;
    	
    	$menu = "<select name=".$name." ".$attrs.">";
    	foreach ($this->_arrMediaTypes as $type => $text) {
			$menu .= "<option value=\"".$type."\"".($selectedType == $type ? " selected=\"selected\"" : "").">".$_ARRAYLANG[$text]."</option>\n";
    	}
		$menu .= "</select>";
		return $menu;
    }
}
?>
