<?php
/**
* Class FWSystem
*
* System related functions
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module framework
* @modulegroups framework
* @access public
* @version 1.0.0
*/

class FWSystem
{
	/**
	* Returns the maximum file size in bytes that is allowed to upload
	*
	* @access private
	* @return string filesize
	*/
	function getMaxUploadFileSize()
	{
		$upload_max_filesize = $this->_getBytes(@ini_get('upload_max_filesize'));
		$post_max_size = $this->_getBytes(@ini_get('post_max_size'));

		if ($upload_max_filesize < $post_max_size) {
			$maxUploadFilesize = $upload_max_filesize;
		} else {
			$maxUploadFilesize = $post_max_size;
		}
		return $maxUploadFilesize;
	}

	/**
	* Returns the value $size in bytes
	*
	* @access private
	* @param $size
	* @return integer
	*/
	function _getBytes($size)
	{
		$size = trim($size);
		$lastChar = strtolower(substr($size,strlen($size)-1));

		switch ($lastChar) {
			case 'g':
				$size *= 1024;
			case 'm':
				$size *= 1024;
			case 'k':
				$size *= 1024;
		}
		return $size;
	}
}
?>
