<?php
/**
* Class block
*
* block library class
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>            
* @module		block
* @modulegroup	modules
* @access		private
* @version		1.0.0
*/
class blockLibrary
{
	/**
	* Block name prefix
	*
	* @access public
	* @var string
	*/
	var $blockNamePrefix = 'BLOCK_';
	
	/**
	* Block ids
	*
	* @access private
	* @var array
	*/
	var $_arrBlocks;

	/**
	* Get blocks
	*
	* Get all block ids
	*
	* @access private
	* @global object $objDatabase
	* @see array blockLibrary::_arrBlocks
	* @return array Array with block ids
	*/
	function _getBlocks()
	{
		global $objDatabase;
		
		if (!is_array($this->_arrBlocks)) {
			$objBlock = $objDatabase->Execute("SELECT id FROM ".DBPREFIX."module_block_blocks");
			if ($objBlock !== false) {
				$this->_arrBlocks = array();
				while (!$objBlock->EOF) {
					array_push($this->_arrBlocks, $objBlock->fields['id']);
					$objBlock->MoveNext();
				}
			}
		}
		return $this->_arrBlocks;
	}
	
	/**
	* add block
	*
	* add the new content of a block
	*
	* @access private
	* @param integer $id
	* @param string $content
	* @global object $objDatabase
	* @return boolean true on success, false on failure
	*/
	function _addBlock($id, $content, $name, $blockRandom)
	{
		global $objDatabase;
		
		
		$query = "INSERT INTO ".DBPREFIX."module_block_blocks (content, name, random) VALUES ('$content', '$name', '$blockRandom')";
		
		if ($objDatabase->Execute($query) !== false) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	* update block
	*
	* Update the content of a block
	*
	* @access private
	* @param integer $id
	* @param string $content
	* @global object $objDatabase
	* @return boolean true on success, false on failure
	*/
	function _updateBlock($id, $content, $name, $blockRandom)
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_block_blocks SET content='".$content."', name='".$name."', random='".$blockRandom."' WHERE id=".$id) !== false) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	* Get block content
	*
	* Return the content of a block
	*
	* @access private
	* @param integer $id
	* @global object $objDatabase
	* @return mixed content on success, false on failure
	*/
	function _getBlockContent($id)
	{
		global $objDatabase;
		
		$objBlock = $objDatabase->SelectLimit("SELECT content FROM ".DBPREFIX."module_block_blocks WHERE id=".$id, 1);
		if ($objBlock !== false) {
			return $objBlock->fields['content'];
		} else {
			return false;
		}
	}
	
	/**
	* Set block
	*
	* Parse the block with the id $id
	*
	* @access private
	* @param integer $id
	* @param string &$code
	* @global object $objDatabase
	*/
	function _setBlock($id, &$code)
	{
		global $objDatabase;
		
		$objBlock = $objDatabase->SelectLimit("SELECT content FROM ".DBPREFIX."module_block_blocks WHERE id=".$id." AND active =1", 1);
		if ($objBlock !== false) {
			$code = str_replace("{".$this->blockNamePrefix.$id."}", $objBlock->fields['content'], $code);
		}
	}
	
	/**
	* Set block Random
	*
	* Parse the block with the id $id
	*
	* @access private
	* @param integer $id
	* @param string &$code
	* @global object $objDatabase
	*/
	function _setBlockRandom(&$code)
	{
		global $objDatabase;
		
		//Get Block Name and Status
		$objBlockName = $objDatabase->Execute("SELECT id FROM ".DBPREFIX."module_block_blocks WHERE active='1' AND random='1'");
		if ($objBlockName !== false) {
			while (!$objBlockName->EOF) {
				$arrActiveBlocks[] = $objBlockName->fields['id'];
				$objBlockName->MoveNext();
			}
		}
		
		$ranId = $arrActiveBlocks[@array_rand($arrActiveBlocks, 1)];
		
		$objBlock = $objDatabase->SelectLimit("SELECT content FROM ".DBPREFIX."module_block_blocks WHERE id=".$ranId." AND active =1", 1);
		if ($objBlock !== false) {
			$code = str_replace("{".$this->blockNamePrefix."RANDOMIZER}", $objBlock->fields['content'], $code);
		}
	}
	
	/**
	* Save settings
	* Save the settings associated to the block system
	*
	* @access private
	* @param array $arrSettings
	* @global objtect $objDatabase
	* @return boolean true on success, false on failure
	*/
	function _saveSettings($arrSettings)
	{
		global $objDatabase, $_CONFIG;
		
		if (isset($arrSettings['blockStatus'])) {
			$_CONFIG['blockStatus'] = (string) $arrSettings['blockStatus'];
			$query = "UPDATE ".DBPREFIX."settings SET setvalue='".$arrSettings['blockStatus']."' WHERE setname='blockStatus'";
			$objDatabase->Execute($query);
		}
		
		if (isset($arrSettings['blockRandom'])) {
			$_CONFIG['blockRandom'] = (string) $arrSettings['blockRandom'];
			$query = "UPDATE ".DBPREFIX."settings SET setvalue='".$arrSettings['blockRandom']."' WHERE setname='blockRandom'";
			$objDatabase->Execute($query);
		}
	}
}
?>
