<?PHP
class ShopLibrary
{
	var $arrShopMailTemplate = array();
	var $arrCurrencies = array();
	var $arrConfig = array();
	var $arrShipment = array();
	var $arrPayment = array();
	
	
	/**
	* Array of all countries
	*
	* @var array [$arrCountries] array of all countries
	* @access public
	* @see _initCountries()
	*/  	
	var $arrCountries = array();


	/**
	* Get an array of the zones
	*
	* @return	array	zones
	*/
	function _getZones()
	{
		global $objDatabase;
		$query = "SELECT zones_id, zones_name, activation_status FROM ".DBPREFIX."module_shop_zones ORDER BY zones_name";
		$objResult = $objDatabase->Execute($query);
		while (!$objResult->EOF) {
			$arrZones[$objResult->fields['zones_id']] = array(
					'zones_id'			=> $objResult->fields['zones_id'],
					'zones_name'		=> $objResult->fields['zones_name'],
					'activation_status'	=> $objResult->fields['activation_status']
					);
			$objResult->MoveNext();
		}
		return $arrZones;
	}
	
	
	/**
	* In_array replacement for multi dim. arrays 
	* NOT USED ANYMORE!
	*
	* @return boolean
	*/	
	function ______in_array_multi($needle, $haystack){
	   $found = false;
	   foreach($haystack as $value) if((is_array($value) && in_array_multi($needle, $value)) || $value == $needle) $found = true;
	   return $found;
	}
	
	
	
	function _getRelCountries()
	{
		global $objDatabase;
		$query("SELECT zones_id, countries_id FROM ".DBPREFIX."module_shop_rel_countries ORDER BY id");	
		$objResult = $objDatabase->Execute($query);
		while (!$objResult->EOF) {
			$arrRelCountries[]=array($objResult->fields['zones_id'],$objResult->fields['countries_id']);
			$objResult->MoveNext();
		}
		return $arrRelCountries;
	}	
	
	
	
    function _getZonesMenu($menuName="zone_id", $selectedId="", $onchange="")
    {
    	global $objDatabase;

        $onchange = !empty($onchange) ? "onchange=\"".$onchange."\"" : "";
        $menu = "<input type=\"hidden\" name=\"old_".$menuName."\" value=\"".$selectedId."\" />\n";
        $menu .= "\n<select name=\"".$menuName."\" ".$onchange.">\n";
        
		$query = "SELECT zones_id, zones_name FROM ".DBPREFIX."module_shop_zones WHERE activation_status=1";
		$objResult = $objDatabase->Execute($query);
		while(!$objResult->EOF) {
			$selected = (intval($selectedId)==$objResult->fields['zones_id']) ? "selected=\"selected\"" : "";
		    $menu .="<option value=\"".$objResult->fields['zones_id']."\" $selected>".$objResult->fields['zones_name']."</option>\n";
		    $objResult->MoveNext();
		}
		$menu .= "</select>\n";
        return $menu;    	    	
    }
	
	

	/**
	* gets a countries select box
	*
	* @param string optional [$menuName] name of the select box
	* @param string optional [$selectedId] pre selected country id	
	* @return string [$menu] select box
	*/  

    function _getCountriesMenu($menuName="countryId", $selectedId="", $onchange="")
    {
    	global $objDatabase;  	

        $onchange = !empty($onchange) ? "onchange=\"".$onchange."\"" : "";
        $menu = "\n<select name=\"".$menuName."\" ".$onchange.">\n";
    	   	
		$query = "SELECT countries_id, 
		                      countries_name 
						 FROM ".DBPREFIX."module_shop_countries
						WHERE activation_status=1";
		$objResult = $objDatabase->Execute($query);
		
		if($objResult->RecordCount()>1) {		
			while (!$objResult->EOF) {    	  	
				$selected = (intval($selectedId)==$objResult->fields['countries_id']) ? "selected=\"selected\"" : "";
			    $menu .="<option value=\"".$objResult->fields['countries_id']."\" ".$selected.">".$objResult->fields['countries_name']."</option>\n";
			    $objResult->MoveNext();
			}
			$menu .= "</select>\n";
		} else {
			$menu = $menu = "\n<input name=\"".$menuName."\" type=\"hidden\" value=\"".$objResult->fields['countries_id']."\">".$objResult->fields['countries_name']."\n";			
		}
        return $menu;    	    	
    }
	
	
	
	
	
	/**
	* gets a select box with all languages
	*
	* @param  string  optional $menuName
	* @param  string  optional $selectedId	
	* @return string $menu
	*/  
    function _getLanguageMenu($menuName="language", $selectedId="")
    {     	
    	// init object from the framework
    	$objShopLanguage = &new FWLanguage();
    	// gets indexed language array
    	$arrLanguage = $objShopLanguage->getLanguageArray();
 	
    	$menu = "\n<select name=\"".$menuName."\">\n";  	
	    $menu .= ($selectedId==0) ? "<option value=\"0\" selected=\"selected\">All</option>\n" : "<option value=\"0\">All</option>\n";  	   	
    	    	
    	foreach($arrLanguage AS $id => $data)
    	{
		    $selected = (intval($selectedId)==$id) ? "selected=\"selected\"" : "";
		    $menu .="<option value=\"".$id."\" $selected>".$data['name']."</option>\n";     		 		
    	}
    	$menu .= "</select>\n";
        return $menu;    	    	
    }   
       
	/**
	* gets a select box with all order statuses
	*
	* @param  string  optional $menuName
	* @param  string  optional $selectedId
	* @param  string  optional $onchange
	* @return string $menu
	*/  
    function _getOrderStatusMenu($menuName="orderStatusId", $selectedId="", $onchange="")
    {
    	$menu = "<select name=\"".$menuName."\" id=\"".$menuName."\" ".($onchange != "" ? "onchange=\"".$onchange."\"" : "").">\n";
    	
    	foreach ($this->arrOrderStatus as $statusId => $strStatus){
    		$menu .= "<option value=\"".$statusId."\" ".($selectedId == $statusId ? "selected=\"selected\"" : "").">".$strStatus."</option>\n";
    	}
    	$menu .= "</select>\n";
    	return $menu;
    }

    
    function _initShipment()
    {
    	global $objDatabase;

     	$query = "SELECT id, 
		                   name, 
		                   costs,
     					   costs_free_sum,
     	                   status
		              FROM ".DBPREFIX."module_shop_shipment
     	             ORDER BY id"; 
     	
     	$objResult = $objDatabase->Execute($query);
     		                    	
	 	while(!$objResult->EOF) {
			$this->arrShipment[$objResult->fields['id']]= array(
			                           'id' => $objResult->fields['id'],
			                           'name' => $objResult->fields['name'],
			                           'costs' => $objResult->fields['costs'],
			                           'costs_free_sum' => $objResult->fields['costs_free_sum'],
			                           'status' => $objResult->fields['status']
			                           );
			$objResult->MoveNext();
		}
    } 
    

    function _initCountries()
    {
    	global $objDatabase;

     	$query = "SELECT countries_id, 
     	                   countries_name,
		                   countries_iso_code_2, 
		                   countries_iso_code_3,
     	                   activation_status
		              FROM ".DBPREFIX."module_shop_countries
     	             ORDER BY countries_id"; 
     	
     	$objResult = $objDatabase->Execute($query);
     		                    	
	 	while(!$objResult->EOF){
			$this->arrCountries[$objResult->fields['countries_id']]= array(
	           'countries_id' => $objResult->fields['countries_id'],
	           'countries_name' => $objResult->fields['countries_name'],
	           'countries_iso_code_2' => $objResult->fields['countries_iso_code_2'],
	           'countries_iso_code_3' => $objResult->fields['countries_iso_code_3'],
	           'activation_status' => $objResult->fields['activation_status']
	           );
	        $objResult->MoveNext();
		}
    }
    
	
	
    function _initPayment()
    {
    	global $objDatabase;

     	$query = "SELECT id, 
		                   name, 
		                   processor_id,
     					   costs,
     					   costs_free_sum,
     	                   sort_order, 	                   
     	                   status
		              FROM ".DBPREFIX."module_shop_payment
     	             ORDER BY sort_order"; 
     	
     	$objResult = $objDatabase->Execute($query);
     		                    	
	 	while(!$objResult->EOF) {
			$this->arrPayment[$objResult->fields['id']]= array(
			                           'id' => $objResult->fields['id'],
			                           'name' => $objResult->fields['name'],
			                           'processor_id' => $objResult->fields['processor_id'],
			                           'costs'	=> $objResult->fields['costs'],
			                           'costs_free_sum'	=> $objResult->fields['costs_free_sum'],
			                           'sort_order' => $objResult->fields['sort_order'],
			                           'status' => $objResult->fields['status']
			                           );
			$objResult->MoveNext();
		}
    } 
    
    
	/**
	* gets a select box with all the payment handlers
	*
	* @param  string  optional $menuName
	* @param  string  optional $selectedhandlerName	
	* @return string $menu
	*/
    function _getPaymentHandlerMenu($menuName="paymentHandler", $selectedhandlerName="Internal")
    {
    	global $objDatabase;
    	$menu = "\n<select name=\"".$menuName."\">\n"; 	
    	// paymentHandlers array from the shopmanager class
    	
    	$query = "SELECT id, name FROM ".DBPREFIX."module_shop_payment_processors WHERE status=1 ORDER BY name";
    	$objResult = $objDatabase->Execute($query);
    	while (!$objResult->EOF) {
    		$selected = ($selectedhandlerName==$objResult->fields['id']) ? "selected=\"selected\"" : "";
			$menu .= "<option value=\"".$objResult->fields['id']."\" ".$selected.">".$objResult->fields['name']."</option>\n";
			$objResult->MoveNext();
    	}
    	$menu .= "</select>\n";
        return $menu;   
    }

    
    
    
    function _getCurrencyPrice($price="0.00")
    {  	
        if($price!="0.00") {       	
        	$price = $price * $this->currencies();    	
        	number_format($price, 2, '.', '');
			$tax_percentaged = round($this->arrConfig['tax_percentaged_value']['value'], 2);			
			$tax = number_format(round((($price/100)*$tax_percentaged)/5,2)*5,2);	        	        	
        }
        else {
        	return $price;          	
        }
    } 
    
    
    
    
    function _initConfiguration()
    {
    	global $objDatabase;

     	$query = "SELECT id, name, value,status FROM ".DBPREFIX."module_shop_config ORDER BY id";
     	$objResult = $objDatabase->Execute($query);
	 	while(!$objResult->EOF) {
			$this->arrConfig[$objResult->fields['name']]= array(
	           'id' => $objResult->fields['id'],
	           'value' => $objResult->fields['value'],
	           'status' => $objResult->fields['status']
	           );
	        $objResult->MoveNext();
		}
    }    
	
	
	
	
	
	
    /*
	* Send Email
	*
    */
    function shopSendmail($shopMailTo,$shopMailFrom,$shopMailFromText,$shopMailSubject,$shopMailBody,$shopMailBcc="" )
    {
         $header = "From: $shopMailFromText <$shopMailFrom>\n";
         /*
         if(!empty($shopMailBcc) AND $this->shopCheckEmail($shopMailBcc)){
         	$header .= "Bcc: $shopMailBcc\n";
         }
         */
	     return @mail($shopMailTo,$shopMailSubject,$shopMailBody,$header);
    }

    
    
    
    /*
	* Send Email
	*
    */
    
    function shopSetMailtemplate($shopTemplateId)
    {
	    GLOBAL $objDatabase;
	    
	    $query = "SELECT content.from_mail AS from_mail,
	                     content.xsender AS xsender,
	                     content.subject AS subject,
	                     content.message AS message 
	                FROM ".DBPREFIX."module_shop_mail AS mail,
	                     ".DBPREFIX."module_shop_mail_content AS content
	               WHERE mail.id=content.tpl_id
	                 AND content.lang_id=".intval($this->langId)." 
	                 AND mail.id =".intval($shopTemplateId);	    
	   if (($objResult = $objDatabase->Execute($query)) !== false) {
	       if (!$objResult->EOF) {
	            $this->arrShopMailTemplate['mail_from']=$objResult->fields['from_mail'];
	            $this->arrShopMailTemplate['mail_x_sender'] = $objResult->fields['xsender'];
	            $this->arrShopMailTemplate['mail_subject'] = $objResult->fields['subject'];
	        	$this->arrShopMailTemplate['mail_body'] = $objResult->fields['message'];
	       }
	       return true;
	   } else {
	   	    return false;
	   }
    }

    
    
    function calculateTax($price)
    {				
		$tax = "0.00";
    	if($this->arrConfig['tax_number']['status'] ==1) {
			$tax_percentaged = round($this->arrConfig['tax_percentaged_value']['value'], 2);			
			$tax = number_format(round((($price/100)*$tax_percentaged)/5,2)*5,2);			
		}		
		return $tax;   	
    }
       
    
     
    function getPercentatedTax()
    {				
    	Global $_ARRAYLANG;
    	$percentagedTax = $_ARRAYLANG['TXT_NO_TAX'];
    	if($this->arrConfig['tax_number']['status'] ==1){
			$percentagedTax = number_format($this->arrConfig['tax_percentaged_value']['value'], 2, '.', '');			
		}
		return $percentagedTax." %";   	
    }   
    
    
    
	/**
	* Validate the email
	*
	* @version 1.0
	* @param  string  $string
	* @return boolean result
	*/
	function shopCheckEmail($string) 
	{
		if( eregi( "^" . "[a-z0-9]+([_\\.-][a-z0-9]+)*" .	//user
			"@" . "([a-z0-9]+([\.-][a-z0-9]+)*)+" .			//domain
			"\\.[a-z]{2,4}" . 								//sld, tld
			"$", $string)
		) {
	        return true;
		} else {
		    return false;
	    }
	}
	
	/**
	* Checks that the email address isn't already used by an other customer
	*
	* @access private
	* @global $objDatabase
	* @param string $email
	* @return boolen
	*/
	function _checkEmailIntegrity($email, $customerId = 0) {
		global $objDatabase;
		
		if ($customerId != 0) {
			$objResult = $objDatabase->SelectLimit("SELECT customerid FROM ".DBPREFIX."module_shop_customers WHERE email='".$email."' AND customerid !=".$customerId, 1);
		} else {
			$objResult = $objDatabase->SelectLimit("SELECT customerid FROM ".DBPREFIX."module_shop_customers WHERE email='".$email."'", 1);
		}
		if ($objResult !== false && $objResult->RecordCount() == 0) {
			return true;
		}
		return false;
	}
	
	/**
	* Checks that the username isn't already used by an other customer
	*
	* @access private
	* @global $objDatabase
	* @param string $email
	* @return boolen
	*/
	function _checkUsernameIntegrity($username, $customerId = 0) {
		global $objDatabase;
		
		if ($customerId != 0) {
			$objResult = $objDatabase->SelectLimit("SELECT customerid FROM ".DBPREFIX."module_shop_customers WHERE username='".$username."' AND customerid !=".$customerId, 1);
		} else {
			$objResult = $objDatabase->SelectLimit("SELECT customerid FROM ".DBPREFIX."module_shop_customers WHERE username='".$username."'", 1);
		}
		if ($objResult !== false && $objResult->RecordCount() == 0) {
			return true;
		}
		return false;
	}
}
?>